/*      Key define         */
#define   F1          0x3b00
#define   F2          0x3c00
#define   F3          0x3d00
#define   F4          0x3e00
#define   F5          0x3f00
#define   F6          0x4000
#define   F7          0x4100
#define   F8          0x4200
#define   F9          0x4300
#define   F10         0x4400
#define   Shift_F1    0x5400
#define   Shift_F2    0x5500
#define   Shift_F3    0x5600
#define   Shift_F4    0x5700
#define   Shift_F5    0x5800
#define   Shift_F6    0x5900
#define   Shift_F7    0x5a00
#define   Shift_F8    0x5b00
#define   Shift_F9    0x5c00
#define   Shift_F10   0x5d00
#define   Ctrl_F1     0x5e00
#define   Ctrl_F2     0x5f00
#define   Ctrl_F3     0x6000
#define   Ctrl_F4     0x6100
#define   Ctrl_F5     0x6200
#define   Ctrl_F6     0x6300
#define   Ctrl_F7     0x6400
#define   Ctrl_F8     0x6500
#define   Ctrl_F9     0x6600
#define   Ctrl_F10    0x6700
#define   Alt_F1      0x6800
#define   Alt_F2      0x6900
#define   Alt_F3      0x6a00
#define   Alt_F4      0x6b00
#define   Alt_F5      0x6c00
#define   Alt_F6      0x6d00
#define   Alt_F7      0x6e00
#define   Alt_F8      0x6f00
#define   Alt_F9      0x7000
#define   Alt_F10     0x7100
#define   Tab         0x0f09
#define   Enter       0x1c0d
#define   UEnter      0xe00d
#define   UP          0x4800
#define   DOWN        0x5000
#define   RIGHT       0x4d00
#define   LEFT        0x4b00
#define   Esc         0x011b
#define   Home        0x4700
#define   End         0x4f00
#define   PgUp        0x4900
#define   PgDn        0x5100
#define   Del         0x5300
#define   Ins         0x5200
#define   Back        0x0e08
#define   SPACE       0x3920
#define   Ctrl_LEFT   0x7300
#define   Ctrl_RIGHT  0x7400
#define   Ctrl_End    0x7500
#define   Ctrl_Home   0x7700
#define   Ctrl_PgUp   0x8400
#define   Ctrl_PgDn   0x7600
#define   Ctrl_Ins    0x9200
#define   Ctrl_A      0x1e01
#define   Ctrl_B      0x3002
#define   Ctrl_C      0x2e03
#define   Ctrl_D      0x2004
#define   Ctrl_E      0x1205
#define   Ctrl_F      0x2106
#define   Ctrl_H      0x2308
#define   Ctrl_I      0x1709
#define   Ctrl_J      0x240a
#define   Ctrl_K      0x250b
#define   Ctrl_L      0x260c
#define   Ctrl_M      0x320d
#define   Ctrl_N      0x310e
#define   Ctrl_O      0x180f
#define   Ctrl_P      0x1910
#define   Ctrl_S      0x1f13
#define   Ctrl_V      0x2f16
#define   Ctrl_X      0x2d18
#define   Ctrl_Y      0x1519
#define   Alt_1       0x7800
#define   Alt_2       0x7900
#define   Alt_3       0x7a00
#define   Alt_O       0x1800
#define   Alt_X       0x2d00
#define   Alt_F       0x2100
#define   Alt_P       0x1900
#define   Alt_V       0x2f00
#define   Alt_W       0x1100
#define   Shift_UP    0x4838
#define   Shift_DOWN  0x5032
#define   Shift_LEFT  0x4b34
#define   Shift_RIGHT 0x4d36
#define   Shift_Ins   0x5230
#define   Shift_Tab   0x0f00

#define   M_base      0x8000

/*   Struct define  */

typedef struct{
	 char Pname[82];
	 int Patt,Pl; /* Pl is the len of Pname   */
	 int Px,Py;
		 /* set where                                            */
    }PMT;

typedef struct{
	 int sx,sy,nx,ny;
	 int att, type, shadow, flag;
	 PMT *winhead;
	 void far *buf;
	 void far *fbuf[3];
	 int bottom;
    }WINDOWSTRU;

typedef struct{
	 char *Vname;
		 /* vname       Vname = NULL                             */
	 int Vatt,Vlen,VLEN,Vdec;
		 /* prompt color                                         */
	 int Vx,Vy;
	 int Vtype;
		 /* char = 0, int =  1  */
	 void *Vuser;
    }VF;

typedef struct{
	 int Rtype; /* 0 = Y / N, 1 = fix, 2 = pop */
	 char Rname[80];
	 int  Rx,Ry,Ratt,Rpatt,Rlen; /* if type == 1 then Rlen = 3       */
	 WINDOWSTRU *Rwin;
		 /*  Rlist window                                        */
	 char **Rlist;
		 /* rname       Vname = NULL                             */
	 void *Ruser;
    }RCHOICE;

typedef struct{
	 int  Ttype;       /* 0 = v,  1 = f */
	 PMT *Tpmt;
		/*  prompt name      Pname = NULL    no Pname            */
	 WINDOWSTRU *Twin;
		/*  Rlist window                                         */
	 char  *Text;
	 int Tatt;
	 unsigned Tlen, Tmlen;
	 char  Tfile[80];
	 void *Tuser;
    }TEXT;

typedef struct{ /* init = NULL;                                       */
	 int cx, cy, ctype, cno, catt;
	 WINDOWSTRU  *win;
	 PMT     *pmt[100];
	 VF      *vfs[100];  /*  ctype = 0 */
	 RCHOICE *rch[50];   /*  ctype = 1 */
	 TEXT    *txt[50];   /*  ctype = 2 */
	 char    hlpname[81];
	 TEXT    *hlp;
    }FIELD;

typedef struct {
	 int type;
	 WINDOWSTRU *win;
	 WINDOWSTRU *winp;
	 char **pp, **pps;
	 int  *x, *y;
	 int ch;
	 int ct,pt;
	 int mpx,mpy,mpl;
	 int status;
    }MENUSTRU;

typedef struct{
	 int	Kflag, Mx, My, Mflag, Mx2, My2;
	 /* if(Mflag==0){ uninstall mouse device }  */
	 /* else{ Mflag = buttom number}            */
    }MK;

typedef struct{
	 char name[12];
	 int  type,len,dec;
    }DBFFIELD;


typedef struct{
	 int recnu,precl,headl,fldno;/*   fldno = (headl-1) / 32 - 1 */
	 DBFFIELD *dfld[300];
    }DBFHEAD;

extern int MouseX, MouseY;
extern int VM, MB;  /* Vido Mode,   Mouse Butom, = 0 mouse not install*/
extern MK mk;

int menu_run(MENUSTRU *menu,int c, int wflag);
save_win(WINDOWSTRU *win);
rest_win(WINDOWSTRU *win);
set_color(int color);
disp_win(WINDOWSTRU *win);
int mouse(int op);
int Get_MK();
